/*
 * Created on Jul 14, 2003
 */
package core;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class PrintOOS extends Thread {

	ObjectOutputStream oos;
	 ByteArrayOutputStream os;
	 String who;

	public PrintOOS(String who,ObjectOutputStream oos, ByteArrayOutputStream os) {
		this.oos=oos;
		this.os=os;
		this.who=who;
	}

	public void run() {
		try {
			synchronized (oos) {
				while (true) {
			oos.wait();
		   byte[] buf=os.toByteArray();
		   ObjectInputStream ois=new ObjectInputStream(new ByteArrayInputStream(buf));
		   printOIS(ois);
			}
		}
		} catch (Exception e) {e.printStackTrace();}
	}
		
		protected void printOIS(ObjectInputStream ois) throws IOException, ClassNotFoundException {
			Object obj=null;
			try {
			while (true) {
				obj=ois.readObject();
			}
			} catch (EOFException e) {}
			if (obj.getClass().getName().compareTo("java.lang.String")==0) {println((String)obj);}
			if (obj.getClass().getName().compareTo("core.Nonce")==0) {
				Nonce n=(Nonce)obj;
				println(n.getId()+": "+n.getString());}
		}
		
	protected void println(String str)
	{
		System.out.println(who+": "+str);
	}
}
